package crosswordsage;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;


public class MainScreen4Rip extends MainScreen {

    static MainScreen4Rip currScreen;
    static MainScreen4Rip wordSolverScreen, crosswordSolverScreen, crosswordBuilderScreen; 
    String name;

    public static void main(String[] args) {
	wordSolverScreen = new MainScreen4Rip("wordSolverScreen");
	crosswordSolverScreen = new MainScreen4Rip("crosswordSolverScreen");  
	crosswordBuilderScreen = new MainScreen4Rip("crosswordBuilderScreen"); 
	switchScreen(wordSolverScreen);
    }

    protected static void switchScreen(MainScreen4Rip screen) {
	MainScreen4Rip[] allScreens = {wordSolverScreen, crosswordSolverScreen, crosswordBuilderScreen};
	for (int i = 0; i < allScreens.length; i++) {
	    if (allScreens[i] == screen)
		allScreens[i].show();
	    else
		allScreens[i].hide();
	}
	if (currScreen != screen)
	    System.out.println("---screen change---");
	currScreen = screen;
	System.out.println("currScreen now " + currScreen);
    }

    public MainScreen4Rip(String n) {
	super();
	name = n;
	for (int i = 0; i < jMenuBar1.getMenuCount(); i++) {
	    JMenu menu = jMenuBar1.getMenu(i);
	    for (int j = 0; j < menu.getItemCount(); j++) {
		JMenuItem item = menu.getItem(j);
		if (item != null) {
		    ActionListener[] listeners = item.getActionListeners();
		    for (int k = 0; k < listeners.length; k++) {
			if (listeners[k] instanceof MenuListener) {
			    item.removeActionListener(listeners[k]);
			    item.addActionListener(new MenuListener4Rip());
			}
		    }
		}
	    }
	}
    }

    public String toString() {
	return name;
    }

    protected static void showCrosswordBuilder4Rip()
    {
	switchScreen(crosswordBuilderScreen);
	currScreen.showCrosswordBuilder();
    }

    protected static void solveCrossword4Rip()
    {
	switchScreen(crosswordSolverScreen);
	currScreen.solveCrossword();
    }

    protected static void loadCrossword4Rip()
    {
	switchScreen(crosswordBuilderScreen);
	currScreen.loadCrossword();
    }

    protected static void solveWord4Rip() {
	switchScreen(wordSolverScreen);
	currScreen.mainPanel.removeAll();
	currScreen.mainPanel.add(new WordSolverPanel());
    }

    class MenuListener4Rip implements ActionListener
    {
        public void actionPerformed(ActionEvent e)
        {
            if (e.getActionCommand() == "Solve New Word")
            {
		solveWord4Rip();
            }
            else if(e.getSource() == mFile_NewCrossword)
            {
                showCrosswordBuilder4Rip();
            }
            else if (e.getActionCommand() == "About")
            {
                showVersion();
            }
            else if (e.getActionCommand() == "Instructions")
            {
                //showInstructions();
            }
            else if(e.getSource().equals(mFile_Load))
            {
                loadCrossword4Rip();
            }
            else if(e.getSource().equals(mFile_Save))
            {
                saveCrossword();
            }
            else if(e.getSource().equals(mFile_Print))
            {
                printCrossword();
            }
            else if(e.getSource().equals(mFile_SolveCrossword))
            {
                solveCrossword4Rip();
            }
            else if(e.getSource().equals(mAction_Publish))
            {
                publishCrossword();
            }
            else if(e.getSource().equals(mEdit_Split))
            {
                splitSelectedWord();
            }
            else if(e.getSource() == mFile_Preferences)
            {
                showPreferences();
            }
            else if(e.getSource().equals(mTools_Version))
            {
                checkNewVersions();
            }
            validate();
        }
    }

}

